--- old/usr/src/man/man3c/Makefile	Sun Aug  5 23:41:08 2018
+++ new/usr/src/man/man3c/Makefile	Sun Aug  5 23:41:08 2018
@@ -27,6 +27,7 @@
 		a64l.3c						\
 		abort.3c					\
 		abs.3c						\
+		accept.3c					\
 		addsev.3c					\
 		addseverity.3c					\
 		aio_cancel.3c					\
@@ -55,6 +56,7 @@
 		atomic_swap.3c					\
 		attropen.3c					\
 		basename.3c					\
+		bind.3c						\
 		bsd_signal.3c					\
 		bsearch.3c					\
 		bstring.3c					\
@@ -73,6 +75,7 @@
 		cnd.3c						\
 		cond_init.3c					\
 		confstr.3c					\
+		connect.3c					\
 		crypt.3c					\
 		crypt_genhash_impl.3c				\
 		crypt_gensalt.3c				\
@@ -179,6 +182,7 @@
 		getpagesize.3c					\
 		getpagesizes.3c					\
 		getpass.3c					\
+		getpeername.3c					\
 		getpeerucred.3c					\
 		getpriority.3c					\
 		getprogname.3c					\
@@ -186,6 +190,8 @@
 		getpwnam.3c					\
 		getrusage.3c					\
 		gets.3c						\
+		getsockname.3c					\
+		getsockopt.3c					\
 		getspnam.3c					\
 		getsubopt.3c					\
 		gettext.3c					\
@@ -224,6 +230,7 @@
 		lckpwdf.3c					\
 		lfmt.3c						\
 		lio_listio.3c					\
+		listen.3c					\
 		localeconv.3c					\
 		lockf.3c					\
 		lsearch.3c					\
@@ -381,6 +388,7 @@
 		readdir.3c					\
 		realpath.3c					\
 		reboot.3c					\
+		recv.3c						\
 		regcmp.3c					\
 		regcomp.3c					\
 		remove.3c					\
@@ -409,6 +417,7 @@
 		sem_unlink.3c					\
 		sem_wait.3c					\
 		semaphore.3c					\
+		send.3c						\
 		setbuf.3c					\
 		setbuffer.3c					\
 		setcat.3c					\
@@ -419,6 +428,7 @@
 		setlocale.3c					\
 		shm_open.3c					\
 		shm_unlink.3c					\
+		shutdown.3c					\
 		sigfpe.3c					\
 		siginterrupt.3c					\
 		signal.3c					\
@@ -429,6 +439,9 @@
 		sigwaitinfo.3c					\
 		sleep.3c					\
 		smt_pause.3c					\
+		sockaddr.3c					\
+		socket.3c					\
+		socketpair.3c					\
 		ssignal.3c					\
 		stack_getbounds.3c				\
 		stack_inbounds.3c				\
@@ -558,7 +571,7 @@
 		wordexp.3c					\
 		wsprintf.3c					\
 		wsscanf.3c					\
-		wstring.3c					\
+		wstring.3c
 
 MANLINKS=	FD_CLR.3c				\
 		FD_ISSET.3c				\
@@ -578,6 +591,7 @@
 		_exithandle.3c				\
 		_flushlbf.3c				\
 		_setjmp.3c				\
+		accept4.3c				\
 		addrtosymstr.3c				\
 		aiowrite.3c				\
 		alloca.3c				\
@@ -1151,6 +1165,8 @@
 		realloc.3c				\
 		reallocarray.3c				\
 		recallocarray.3c			\
+		recvfrom.3c				\
+		recvmsg.3c				\
 		regerror.3c				\
 		regex.3c				\
 		regexec.3c				\
@@ -1179,6 +1195,8 @@
 		sema_post.3c				\
 		sema_trywait.3c				\
 		sema_wait.3c				\
+		sendmsg.3c				\
+		sendto.3c				\
 		setattrat.3c				\
 		setgrent.3c				\
 		sethostname.3c				\
@@ -1188,6 +1206,7 @@
 		setpriority.3c				\
 		setprogname.3c				\
 		setpwent.3c				\
+		setsockopt.3c				\
 		setspent.3c				\
 		setstate.3c				\
 		settimeofday.3c				\
@@ -1213,6 +1232,12 @@
 		sigtimedwait.3c				\
 		single_to_decimal.3c			\
 		snprintf.3c				\
+		sockaddr_dl.3c				\
+		sockaddr_in.3c				\
+		sockaddr_in6.3c				\
+		sockaddr_ll.3c				\
+		sockaddr_storage.3c			\
+		sockaddr_un.3c				\
 		sprintf.3c				\
 		srand.3c				\
 		srand48.3c				\
@@ -1436,6 +1461,8 @@
 labs.3c					:= LINKSRC = abs.3c
 llabs.3c				:= LINKSRC = abs.3c
 
+accept4.3c				:= LINKSRC = accept.3c
+
 aiowrite.3c				:= LINKSRC = aioread.3c
 
 arc4random_buf.3c			:= LINKSRC = arc4random.3c
@@ -1829,6 +1856,8 @@
 
 fgets.3c				:= LINKSRC = gets.3c
 
+setsockopt.3c				:= LINKSRC = getsockopt.3c
+
 endspent.3c				:= LINKSRC = getspnam.3c
 fgetspent.3c				:= LINKSRC = getspnam.3c
 fgetspent_r.3c				:= LINKSRC = getspnam.3c
@@ -2222,6 +2251,9 @@
 
 readdir_r.3c				:= LINKSRC = readdir.3c
 
+recvfrom.3c				:= LINKSRC = recv.3c
+recvmsg.3c				:= LINKSRC = recv.3c
+
 regex.3c				:= LINKSRC = regcmp.3c
 
 regerror.3c				:= LINKSRC = regcomp.3c
@@ -2267,6 +2299,9 @@
 sema_trywait.3c				:= LINKSRC = semaphore.3c
 sema_wait.3c				:= LINKSRC = semaphore.3c
 
+sendmsg.3c				:= LINKSRC = send.3c
+sendto.3c				:= LINKSRC = send.3c
+
 setvbuf.3c				:= LINKSRC = setbuf.3c
 
 setlinebuf.3c				:= LINKSRC = setbuffer.3c
@@ -2289,6 +2324,13 @@
 
 sigtimedwait.3c				:= LINKSRC = sigwaitinfo.3c
 
+sockaddr_dl.3c				:= LINKSRC = sockaddr.3c
+sockaddr_in.3c				:= LINKSRC = sockaddr.3c
+sockaddr_in6.3c				:= LINKSRC = sockaddr.3c
+sockaddr_ll.3c				:= LINKSRC = sockaddr.3c
+sockaddr_storage.3c			:= LINKSRC = sockaddr.3c
+sockaddr_un.3c				:= LINKSRC = sockaddr.3c
+
 gsignal.3c				:= LINKSRC = ssignal.3c
 
 stderr.3c				:= LINKSRC = stdio.3c